package examples.jce.rsa_aes;

import java.io.*;
import javax.crypto.*;

/**
 * MacOutputStream. As data it writen it passes it updates a MAC.
 */

public class MacOutputStream extends FilterOutputStream
{
    private Mac mac = null;

    public MacOutputStream(
        OutputStream    out,
        Mac             mac)
    {
        super(out);
        this.mac = mac;
    }

    public void write(
        int b)
        throws IOException
    {
        mac.update((byte)b);
        out.write(b);
    }
    
    public void write(
        byte[] b)
        throws IOException
    {
        mac.update(b);
        out.write(b);
    }

    public void write(
        byte[]  b,
        int     o,
        int     l)
        throws IOException
    {
        mac.update(b, o, l);
        out.write(b, o, l);
    }
}
